/**
  PasswordMaker - Creates and manages passwords
  Copyright (C) 2005 Eric H. Jung and LeahScape, Inc.
  http://passwordmaker.org/
  grimholtz@yahoo.com

  This library is free software; you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation; either version 2.1 of the License, or (at
  your option) any later version.

  This library is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESSFOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
  for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with this library; if not, write to the Free Software Foundation,
  Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
**/

function onAccountsTreeSelection() {
  if (!onTreeSelection())
    return;
  
  if (accountsTree.view.rowCount == 0)
    return;
    
  // if a folder...  
  if (accountsTree.view.getItemAtIndex(accountsTree.currentIndex).getAttribute("container") == "true") {
    document.getElementById("clipboardCopyCmd").setAttribute("disabled", true);
    document.getElementById("isFolderCmd").setAttribute("style", "display: none;");
  }
  else {
    updateURLLabel();
    generatepassword();   // If not a folder, generate password
    document.getElementById("clipboardCopyCmd").setAttribute("disabled", false);
    document.getElementById("isFolderCmd").setAttribute("style", "display: block;");
  }  
}

// accounts-tree-specific fcn
function getUrlToUse() {
    var cells = getTreeCells(accountsTree);
    return accountsTree.currentIndex == 0 ?
      
    // Defaults
    passwordMaker.calculateURI(cells[6].getAttribute("label") == "true", // protocolCB
      cells[7].getAttribute("label") == "true", // subdomainCB
      cells[8].getAttribute("label") == "true", // domainCB
      cells[9].getAttribute("label") == "true", // pathCB
      cells[9].getAttribute("label") == "true") : // pathCB
    
    // A specific account
    cells[11].getAttribute("label");
}

function onOtherFields() {
  var temp = getActiveTreeInfo();
  var params = {inn:{passwordMaker:passwordMaker, accountRes:temp.subjectRes}, out : null};
  window.openDialog("chrome://passwdmaker/chrome/fields.xul", "", "chrome, dialog, modal, resizable=yes", params).focus();
}

function onAccountSettings(isNew) {
  var temp = getActiveTreeInfo();
 
  // Get current settings from the UI (we could get them from the RDF instead).
  // If a new account, use the default settings
  var cells;
  var containerRes;
  if (isNew) {
    // Get existing (selected by user) container
    containerRes = PwdMkr_RDFUtils.rdfContainerUtils.MakeSeq(PwdMkr_RDFUtils.datasource, temp.subjectRes);       
    temp.subjectRes = PwdMkr_RDFUtils.makeResource(); // create a new res for the new acct
  }
  else {
    cells = getTreeCells(temp.tree);
    if (temp.isContainer) {
      createNewFolder("name", "description", temp.container, temp.subjectRes,
        cells[0].getAttribute("label"), cells[1].getAttribute("label"));
      return;    
    }
  }    
  
  if (temp.isAccounts) {
    if (isNew)
      cells = getTreeCells(temp.tree, 0); // Defaults
     // Only the accounts tree has a "default" account
    var isDefaultsAccount = temp.tree.currentIndex == 0;
    var accountSettings = {isDefaultsAccount : isDefaultsAccount,
      accountName : isNew ? "New Account" : cells[0].getAttribute("label"),
      accountDescription : isNew ? "" : cells[1].getAttribute("label"),
      whereLeetLB : cells[2].getAttribute("label"),
      leetLevelLB : cells[3].getAttribute("label"), hashAlgorithmLB : cells[4].getAttribute("label"),
      passwordLength : cells[5].getAttribute("label"), protocolCB : cells[6].getAttribute("label"),
      subdomainCB : cells[7].getAttribute("label"), domainCB : cells[8].getAttribute("label"),
      pathCB : cells[9].getAttribute("label"), urlToMatch : (isDefaultsAccount ? getUrlToUse() : cells[10].getAttribute("label")),
      urlToUse : (isDefaultsAccount ? getUrlToUse() : cells[11].getAttribute("label")), usernameTB : cells[12].getAttribute("label"),
      counter : cells[13].getAttribute("label"), charset : cells[14].getAttribute("label"), prefix : cells[15].getAttribute("label"),
      suffix : cells[16].getAttribute("label"), autoPop : cells[17].getAttribute("label")};
  
    var params = {inn:{accountSettings:accountSettings, passwordMaster:passwordMaster.value,
      passwordMaker:passwordMaker}, out : null};
  
    window.openDialog("chrome://passwdmaker/chrome/accountsettings.xul", "",
      "chrome, dialog, modal, resizable=yes", params).focus();

    if (params.out) {
      // User clicked OK - update datasource
      accountSettings = params.out.accountSettings;
      PwdMkr_RDFUtils.updateTarget(temp.subjectRes, "name", accountSettings.accountName);
      PwdMkr_RDFUtils.updateTarget(temp.subjectRes, "description", accountSettings.accountDescription);
      PwdMkr_RDFUtils.updateTarget(temp.subjectRes, "whereLeetLB", accountSettings.whereLeetLB);
      PwdMkr_RDFUtils.updateTarget(temp.subjectRes, "leetLevelLB", accountSettings.leetLevelLB);
      PwdMkr_RDFUtils.updateTarget(temp.subjectRes, "hashAlgorithmLB", accountSettings.hashAlgorithmLB);
      PwdMkr_RDFUtils.updateTarget(temp.subjectRes, "passwordLength", accountSettings.passwordLength);
      PwdMkr_RDFUtils.updateTarget(temp.subjectRes, "usernameTB", accountSettings.usernameTB);
      PwdMkr_RDFUtils.updateTarget(temp.subjectRes, "counter", accountSettings.counter);
      PwdMkr_RDFUtils.updateTarget(temp.subjectRes, "charset", accountSettings.charset);
      PwdMkr_RDFUtils.updateTarget(temp.subjectRes, "prefix", accountSettings.prefix);
      PwdMkr_RDFUtils.updateTarget(temp.subjectRes, "suffix", accountSettings.suffix);
      PwdMkr_RDFUtils.updateTarget(temp.subjectRes, "autoPopulate", accountSettings.autoPop ? "true" : "false");
      if (isDefaultsAccount) {
        // The defaults node is selected
        PwdMkr_RDFUtils.updateTarget(temp.subjectRes, "protocolCB", accountSettings.protocolCB ? "true" : "false");
        PwdMkr_RDFUtils.updateTarget(temp.subjectRes, "subdomainCB", accountSettings.subdomainCB ? "true" : "false");
        PwdMkr_RDFUtils.updateTarget(temp.subjectRes, "domainCB", accountSettings.domainCB ? "true" : "false");
        PwdMkr_RDFUtils.updateTarget(temp.subjectRes, "pathCB", accountSettings.pathCB ? "true" : "false");
      }
      else {
        // Especially don't write urlToMatch to the defaults account, otherwise the default will match weird stuff!
        PwdMkr_RDFUtils.updateTarget(temp.subjectRes, "urlToMatch", accountSettings.urlToMatch); 
        PwdMkr_RDFUtils.updateTarget(temp.subjectRes, "urlToUse", accountSettings.urlToUse);      
      }
      params = null; // proactive clearing of sensitive data
      if (containerRes) {
        // Add the resource to the container (folder)
        containerRes.AppendElement(temp.subjectRes);
      }      
      PwdMkr_RDFUtils.flush(); // gen password AFTER flushing so tree is up-to-date for generation
      if (!temp.isContainer) {
        updateURLLabel();
        generatepassword();
      }
      passwordMaker.loadURLs(); // refresh arrays
    }      
  }
  else if (temp.isRemotes) {
    onRemoteAccountSettings(temp, cells, isNew, containerRes);
  }

}
