/**
  PasswordMaker - Creates and manages passwords
  Copyright (C) 2005 Eric H. Jung and LeahScape, Inc.
  http://passwordmaker.org/
  grimholtz@yahoo.com

  This library is free software; you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation; either version 2.1 of the License, or (at
  your option) any later version.

  This library is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESSFOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
  for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with this library; if not, write to the Free Software Foundation,
  Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
**/

var accounts, passwordMaker, accountsTree;

function onLoad() {
  accounts = window.arguments[0].inn.accounts;
  passwordMaker = window.arguments[0].inn.passwordMaker;
  accountsTree = document.getElementById("accountsTree");
  accountsTree.view = {
    rowCount : accounts.length,
    getCellText : function(row, column){
      var s = column.id ? column.id : column;
      switch(s) {
        case "nameCol":return passwordMaker._getLiteral(accounts[row], passwordMaker.namePredicateRes);
        case "descriptionCol":return passwordMaker._getLiteral(accounts[row], passwordMaker.descriptionPredicateRes);
        case "usernameCol":return passwordMaker._getLiteral(accounts[row], passwordMaker.usernameTBPredicateRes);
        case "whereLeetLBCol":return passwordMaker._getLiteral(accounts[row], passwordMaker.whereLeetLBPredicateRes);
        case "leetLevelLBCol":return passwordMaker._getLiteral(accounts[row], passwordMaker.leetLevelLBPredicateRes);
        case "hashAlgorithmLBCol":return passwordMaker._getLiteral(accounts[row], passwordMaker.hashAlgorithmLBPredicateRes);
        case "passwordLengthCol":return passwordMaker._getLiteral(accounts[row], passwordMaker.passwordLengthPredicateRes);
        case "urlToMatchCol":return passwordMaker._getLiteral(accounts[row], passwordMaker.urlToMatchPredicateRes);
        case "urlToUseCol":return passwordMaker._getLiteral(accounts[row], passwordMaker.urlToUsePredicateRes);
        case "counterCol":return passwordMaker._getLiteral(accounts[row], passwordMaker.counterPredicateRes);
        case "autoPopulateCol":return passwordMaker._getLiteral(accounts[row], passwordMaker.autoPopulatePredicateRes);
        case "charsetCol":return passwordMaker._getLiteral(accounts[row], passwordMaker.charsetPredicateRes);
        case "prefixCol":return passwordMaker._getLiteral(accounts[row], passwordMaker.prefixPredicateRes);
        case "suffixCol":return passwordMaker._getLiteral(accounts[row], passwordMaker.suffixPredicateRes);        
      }
    },
    isSeparator: function(aIndex) { return false; },
    isSorted: function() { return false; },
    isContainer: function(aIndex) { return false; },
    setTree: function(aTree){},
    getImageSrc: function(aRow, aColumn) {return null;},
    getProgressMode: function(aRow, aColumn) {},
    getCellValue: function(aRow, aColumn) {},
    cycleHeader: function(aColId, aElt) {},
    getRowProperties: function(aRow, aColumn, aProperty) {},
    getColumnProperties: function(aColumn, aColumnElement, aProperty) {},
    getCellProperties: function(aRow, aProperty) {},
    getLevel: function(row){ return 0; }
  };
  accountsTree.view.selection.select(0);
  document.getElementById("label").value = accounts.length + " accounts match this URL. Select one to use for auto-population, or click cancel.";
  sizeToContent();
}
  
function onOK() {
  window.arguments[0].out = new Object();
  window.arguments[0].out.selection = window.arguments[0].inn.accounts[accountsTree.currentIndex];
  return true;
}

